/**
 * Parse object key from dot notation
 * @example
 * parseKey('person.name', 'John Doe');
 * // outputs { person: { name: 'John Doe' } }
 * parseKey('person.alias[]', 'John Doe');
 * // outputs { person: { alias: ['John Doe] } }
 * @param {string} path - Dot notation object path
 * @param {any} value - Dot notation path value
 * @returns {object}
 */
declare const parseKey: <T>(path: string, value: unknown) => T extends [] ? T[] : T;
export default parseKey;
